
var CarouselGraphic = null;

(function($){
  
  CarouselGraphic = Class.extend({
      
     init: function(options) {
	 var self = this;
	this.defaults = {
		    userName: 'Andreas',
		    userAge: '13',
		    iconCount: 10,
		    formCanvas: '',
		    button: '#next',
		    data: [
				{   label: 'Handykosten', 
				    question: 'Woher bekommst du dein Telefon und wieviel musst du dafür bezahlen?', 
				    select: [
						{
						 option: {label: 'Geschenk/Tausch'},
						 input: [],
						 callback: function(value) {return 0;}
						},
						{
						 option: {label: 'Einmalige Anschaffung'},
						 input: [
						    {id: 'in1', type:'text', value:'', label:'Kaufpreis'}
						 ],
						 callback: function(value) {
						     return Math.round(parseInt($('#in1').val())/24); 
						 }
						},
						{
						 option: {label: 'Ratenkauf ohne Anzahlung'},
						 input: [
						    {id: 'in2', type:'text', value:'', label:'monatliche Rate'}
						 ],
						 callback: function(value) {
						     return Math.round(parseInt($('#in2').val())/24);
						 }
						},
						{
						 option: {label: 'Ratenkauf mit Anzahlung'},
						 input: [
						    {id: 'in3', type:'text', value:'', label:'Einmalige Anzahlung'},
						    {id: 'in4', type:'text', value:'', label:'monatliche Rate'}
						 ],
						 callback: function(value) {
						     return Math.round((parseInt($('#in4').val()) - parseInt($('#in3').val()))/24);
						 }
						}
				    ]
				},
				{   label: 'Handykosten', 
				    question: 'Woher bekommst du dein Telefon und wieviel musst du dafür bezahlen?', 
				    select: [
						{
						 option: {label: 'Geschenk/Tausch'},
						 input: [],
						 callback: function(value) {return 0;}
						},
						{
						 option: {label: 'Einmalige Anschaffung'},
						 input: [
						    {id: 'in5', type:'text', value:'', label:'Kaufpreis'}
						 ],
						 callback: function(value) {
						     return Math.round(parseInt($('#in5').val())/24); 
						 }
						},
						{
						 option: {label: 'Ratenkauf ohne Anzahlung'},
						 input: [
						    {id: 'in6', type:'text', value:'', label:'monatliche Rate'}
						 ],
						 callback: function(value) {
						     return Math.round(parseInt($('#in6').val())/24);
						 }
						},
						{
						 option: {label: 'Ratenkauf mit Anzahlung'},
						 input: [
						    {id: 'in7', type:'text', value:'', label:'Einmalige Anzahlung'},
						    {id: 'in8', type:'text', value:'', label:'monatliche Rate'}
						 ],
						 callback: function(value) {
						     return Math.round((parseInt($('#in8').val()) - parseInt($('#in7').val()))/24);
						 }
						}
				    ]
				}
		    ]
		}
		this.value = 0;
		this.statusText = '';
		this.opt = $.extend(this.defaults, options);     
		this.iniViews();
		$(this.opt.button).bind('click', function() {
		    self.openDialog();
		})
     },
     
     
     iniViews: function() {
		 var self = this;
		 
		 this.opt.formCanvas.append( 
		    '<div id="g_dialog" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">'+
		    '<div class="modal-header">'+
		    '<button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>'+
		    '<h3 id="g_header">Modal header</h3>'+
		    '</div>'+
		    '<div id="g_cont" class="modal-body"></div>'+
		    '<div class="modal-footer">'+
		    '<button class="btn" data-dismiss="modal" aria-hidden="true">Ok</button>'+
		    '</div>'+
		    '</div>' );
		 
		 for(var i in this.opt.data) {
		     var select = $('<select i="'+i+'"></select>')
		     for(var k=0; k < this.opt.data[i].select.length; k++) {
			 select.append( $('<option value="'+k+'">'+this.opt.data[i].select[k].option.label+'</option>') );
		     }
		     	     
		     var node = $(  '<div>'+
				    '<div class="item">'+
				    '	<div class="ilabel textur">'+this.opt.data[i].label+'</div>'+
				    '	<div class="cont">'+
				    '	    '+this.opt.data[i].question+' '+
				    '	    <div class="inputSpacer"></div>'+
				    '	</div>'+		    
				    '	</div>'+
				    '</div>');
				
		     select.bind('change', function() {
			 self.selectAction(this);
		     });
		     node.find('.cont .inputSpacer:first').append(select);	
		     $(this.opt.formCanvas).append(node);
		     self.selectAction(select);
		 }
		 
		$("#carousel_canvas").CloudCarousel({			
		    xPos: 210,
		    yPos: 21,
		    minScale: 0.8,
		    xRadius:110,
		    yRadius:1,
		    mouseWheel: true,
		    bringToFront: true,
		    buttonLeft: $("#left-but"),
		    buttonRight: $("#right-but"),
		    altBox: $("#alt-text"),
		    titleBox: $("#title-text"),
		    wheelcontainer: $('#overLayCont')
		});
		
		
		for(var i=0; i < this.opt.iconCount; i++) {
		    var item = $('<div class="icon ptextur"></div>');
		    item.css('backgroundPosition', (i*44*-1)+'px 0px');
		    $(this.opt.formCanvas).find('.drag:first').append(item);
		}
		
		this.flipView = new FlipView({
			containerId: $(this.opt.formCanvas).find('.drag:first'),
			itemClass: ".icon",
			spaceBetweenItems: 5,
			itemWidth: 44,
			itemHeight: 72,
			dragTolerance: 5,
			animationType: 'linear',
			dragDisable: false
		 });
		 
		 this.opt.formCanvas.find('.iGoLeft').bind('click', function() {
		    self.flipView.slideToLeft();
		 });
		 
		 this.opt.formCanvas.find('.iGoRight').bind('click', function() {
		    self.flipView.slideToRight();
		 });
		
		$(this.opt.formCanvas).find('.name').html(this.opt.userName+', '+this.opt.userAge+' Jahre');
		
		
     },     
     
     selectAction: function(node){
		 var self = this;
		 var i = parseInt($(node).attr('i'));
		 var v = parseInt($(node).val());
		 $(node).parent().find('input').remove();
		 $(node).parent().find('.clear').remove();
		 for(var x=0;  x < self.opt.data[i].select[v].input.length; x++) {
		     var input = self.opt.data[i].select[v].input[x];
		     var inputNode = $('<input id="'+input.id+'" type="'+input.type+'" value="'+input.value+'" title="'+input.label+'"/>');
		     inputNode.tooltip({title: 'title'});
		     inputNode.bind('keyup', function() {
		    	 self.opt.data[i].select[v].value = self.opt.data[i].select[v].callback(self.value);
		    	 self.updateResult();
		     });
		     $(node).parent().append(inputNode);
		 }
		 $(node).parent().append('<div class="clear"></div>');
     },
     
     updateResult: function() {
		 var self = this;
		 var v = 0;
		 $(this.opt.formCanvas).find('select').each(function(i, elem){
			 if(self.opt.data[i].select[elem.selectedIndex].value) {
				 v += self.opt.data[i].select[elem.selectedIndex].value;
			 }else if(self.opt.data[i].select[elem.selectedIndex].input.length == 0) {
				 self.statusText = self.opt.data[i].select[elem.selectedIndex].callback(v);
			 }
		 });
		 
		 $(this.opt.formCanvas).find('.bottom').html(v+' €');
		 self.value = v;		 
     },
     
    openDialog: function() {
	 var self = this;
	 if(self.statusText == "") return;

	 $( "#g_header" ).html('Deine Gesamtkosten auf zwei Jahre gerechnet: '+self.value+' €');
	 $( "#g_cont" ).html(self.statusText);
	 $( "#g_dialog" ).modal('show');
     }
  });
  
})(jQuery);