

var DragInfoItem = null;

(function($){
  
  DragInfoItem = Class.extend({
      
     init: function(options) {
	 var self = this;	    
	 this.defaults = {
	     canvas: null,
	     id: null,
	     type: null,
	     data: { desc:'', price: 0},
	     control: null
	 }	 
	 
	 if(options.type) options.type = parseInt(options.type);
	 
	 this.opt = $.extend(this.defaults, options);
	 this.opt.canvas = $(this.opt.canvas);
	 this.opt.canvas.attr('item_id', this.opt.id);	
	 
	 this.from = $(	    '<div class="small"><div class="flag textur"></div><div class="cont"></div></div>'+
			    '<div class="formContainer">'+
			    '	<div class="form" style="display:none;">'+
			    '	    <div class="flag textur"></div>'+
			    '	    <label class="fSelect" style="display:none; height:auto;">Art:'+
			    '		<select>'+
			    '		    <option value="1" '+( (this.opt.type ==1)? 'selected="selected"':'')+'>Monatliche Anschaffung</option>'+
			    '		    <option value="12" '+( (this.opt.type ==12)? 'selected="selected"':'')+'>Einmalige Anschaffung</option>'+
			    '		</select>'+
			    '		<button class="btn b2">OK</button>'+
			    '	    </label>'+
			    '	    <div class="fFields">'+
			    '	    	<label>Beschreibung:<input type="text" name="desc" maxlength="30" value="'+this.opt.data.desc+'"/></label>'+
			    '	    	<label>Preis:'+
			    '	    		<div class="input-append">'+
			    '	    		    <input maxlength="5" type="text" name="price" style="width: 131px;" value="'+this.opt.data.price+'"/>'+
			    '	    		    <button class="btn b1">OK</button>'+
			    '	    		</div>'+
			    '	    	</label>'+
			    '	    </div>'+
			    '	</div>'+
			    '</div>');
	 
	 this.inDrag = false;
	 
	 this.formValid = false;
	 if(this.opt.data.price > 0 && this.opt.data.desc!="") {
	     this.formValid = true;
	 }
	 
	 this.formIsShow = false;
	 
	 this.createForm();
	 this.setSmallView();
	 
	 this.opt.canvas.bind('click', function() {
	     if(self.formIsShow == false && self.opt.control.checkItems() && !self.inDrag ) {
		self.opt.control.closeOtherItems(self.opt.id);
		self.showForm();
	     }
	 });	
     },
     
     giveMonthPrice: function() {
	 var self = this;
	 if(self.formValid) {
	    return Math.round( (self.opt.data.price / self.opt.type) );
	 }else {
	     return 0;
	 }
     },
     
     createForm: function() {
	 var self = this;
	 
	 this.opt.canvas.append(this.from);
	 this.opt.canvas.find('.formContainer button.b1').bind(
	    'click',
	    function(event) {		
		self.opt.type = self.opt.canvas.find('.formContainer select').first().val();
		self.opt.data.desc = self.opt.canvas.find('.formContainer input[name="desc"]').first().val();
		self.opt.data.price = parseInt( self.opt.canvas.find('.formContainer input[name="price"]').first().val() );
		
		if(!self.opt.data.price || self.opt.data.desc == "") {
		    self.opt.data.price = (self.opt.data.price)? self.opt.data.price:0;
		    self.formValid = false;
		    self.opt.control.checkItems();
		}else {
		    self.formValid = true;
		    event.stopPropagation()		    
		}
				
		self.opt.canvas.find('.formContainer input[name="price"]').first().val(self.opt.data.price);
		
		if(self.formValid == true && self.opt.data.price >= 200) {
		    self.opt.canvas.find('.fFields').hide();
		    self.opt.canvas.find('.fSelect').show();
		    //		    
		}else if(self.formValid == true) {	
		    self.opt.type = 1;
		    self.opt.control.checkItems();
		    self.hideForm();
		    self.setSmallView();
		}
	    }
	 );
	     
	 this.opt.canvas.find('.formContainer button.b2').bind(
	    'click',
	    function(event) {
		self.opt.type = self.opt.canvas.find('.formContainer select').first().val();
		self.hideForm();
		self.opt.control.checkItems();
		self.setSmallView();
	    });
	    
     },
     
     setSmallView: function() {
	var self = this;
	self.opt.canvas.find('.small .cont').html(
	    '<div class="txt">'+self.opt.data.desc+'</div>'+
	    '<div class="price">'+( (self.opt.type!=1)? 'mtl. '+self.giveMonthPrice():self.opt.data.price )+' €</div>'
	);
     },
     
     showForm: function() {
	 var self = this;
	 self.formIsShow = true;
	 self.opt.canvas.find('.formContainer .form').show();
	 self.opt.canvas.find('.small').hide();	 
	 self.opt.canvas.removeClass('small');
     },
     
     hideForm: function() {
	 var self = this;
	 setTimeout(function() {
	     self.formIsShow = false;
	 },100);
	 
	 self.opt.canvas.find('.fFields').show();
	 self.opt.canvas.find('.fSelect').hide();
	 
	 self.opt.canvas.find('.formContainer .form').hide();
	 self.opt.canvas.find('.small').show();
	 setTimeout(function() {
	     if(self.opt.canvas.find('.small').first().height() > 25) {
		 self.opt.canvas.addClass('smaller');
	     }else {
		 self.opt.canvas.removeClass('smaller');
	     }
	 },50);
	 self.opt.canvas.addClass('small');
     },
     
     destroy: function() {
	 var self = this;
	 self.opt.canvas.remove();
     }
 
  })
  
})(jQuery)